Index: BLFS/libs/func_dependencies
===================================================================
--- BLFS/libs/func_dependencies	(revision dc7fd7b7bafa287dad8dd54df9b4814ef6a9f16c)
+++ BLFS/libs/func_dependencies	(revision 2e1c1c3c167303f88f79567d4588098a71af797f)
@@ -129,5 +129,5 @@
   if [ -f ${id_of_dep}.dep ]; then # found ${id_of_dep}.dep already in tree
     otherlink=($(head -n 1 ${id_of_dep}.dep))
-    if [ -z "${otherlink[*]}" ] 
+    if [ -z "${otherlink[*]}" ]
       then echo otherlink empty for $id_of_dep.dep
       echo This should not happen, but happens to happen...
Index: BLFS/xsl/gen_pkg_list.xsl
===================================================================
--- BLFS/xsl/gen_pkg_list.xsl	(revision dc7fd7b7bafa287dad8dd54df9b4814ef6a9f16c)
+++ BLFS/xsl/gen_pkg_list.xsl	(revision 2e1c1c3c167303f88f79567d4588098a71af797f)
@@ -195,5 +195,5 @@
                                                          '123456789',
                                                          '000000000'),
-                                                '-0')    
+                                                '-0')
                                       ]"
             mode="normal">
Index: BLFS/xsl/make_book.xsl
===================================================================
--- BLFS/xsl/make_book.xsl	(revision dc7fd7b7bafa287dad8dd54df9b4814ef6a9f16c)
+++ BLFS/xsl/make_book.xsl	(revision 2e1c1c3c167303f88f79567d4588098a71af797f)
@@ -152,7 +152,7 @@
             <xsl:choose>
               <xsl:when test="@linkend='bootscripts' or
-                              @linkend='systemd-units'"> 
+                              @linkend='systemd-units'">
                 <xsl:copy-of select="."/>
-              </xsl:when> 
+              </xsl:when>
               <xsl:otherwise>
                 <xsl:value-of select="@linkend"/> (in full book)
@@ -293,5 +293,5 @@
 
 <!-- The case of depdendencies of perl modules. Same treatment
-     as for perl modules. Just easier because always perl standard --> 
+     as for perl modules. Just easier because always perl standard -->
   <xsl:template match="para">
     <xsl:element name="sect1">
Index: CLFS/master.sh
===================================================================
--- CLFS/master.sh	(revision dc7fd7b7bafa287dad8dd54df9b4814ef6a9f16c)
+++ CLFS/master.sh	(revision 2e1c1c3c167303f88f79567d4588098a71af797f)
@@ -829,5 +829,5 @@
 
     case $this_script in
-      *choose)   continue ;; # This is not a script but a commentary. 
+      *choose)   continue ;; # This is not a script but a commentary.
       *dhcp)    continue ;; # Assume static networking.
       *dhcpcd)    continue ;; # Assume static networking.
@@ -1016,5 +1016,5 @@
   [[ "$COMPARE" = "y" ]] && wrt_compare_targets
   bootscripts_Makefiles          # mk_BOOTSCRIPT (CHROOT) $bootscripttools
-  if [ -d network ]; then 
+  if [ -d network ]; then
      network_Makefiles           # If present, process network setup.
   fi
Index: FUNCTION_LIST
===================================================================
--- FUNCTION_LIST	(revision dc7fd7b7bafa287dad8dd54df9b4814ef6a9f16c)
+++ FUNCTION_LIST	(revision 2e1c1c3c167303f88f79567d4588098a71af797f)
@@ -40,5 +40,5 @@
 Description: Runs xsltproc with stylesheet urls.xsl on chapter 3 of the
 book. Add BLFS dependencies and custom dependencies if `BLFS_TOOLS' is `y'
-and `CUSTOM_TOOLS' is `y' respectively. 
+and `CUSTOM_TOOLS' is `y' respectively.
 Called by: get_sources
 --------------------------------------------------------------------------
@@ -69,5 +69,5 @@
 Implements the behavior described in README.CUSTOM, that is, if script_name
 begins with d-, strip that part.
-Called by: various functions in master.sh 
+Called by: various functions in master.sh
 --------------------------------------------------------------------------
 LUSER_wrt_target():
@@ -129,65 +129,65 @@
 CHROOT_wrt_RunAsRoot():
 From common/libs/func_wrt_Makefile.
-Description: 
+Description:
 --------------------------------------------------------------------------
 LUSER_wrt_CopyFstab():
 From common/libs/func_wrt_Makefile.
-Description: 
+Description:
 --------------------------------------------------------------------------
 CHROOT_wrt_CopyFstab():
 From common/libs/func_wrt_Makefile.
-Description: 
+Description:
 --------------------------------------------------------------------------
 LUSER_wrt_TouchTimestamp():
 From common/libs/func_wrt_Makefile.
-Description: 
+Description:
 --------------------------------------------------------------------------
 CHROOT_wrt_TouchTimestamp():
 From common/libs/func_wrt_Makefile.
-Description: 
+Description:
 --------------------------------------------------------------------------
 LUSER_wrt_LogNewFiles():
 From common/libs/func_wrt_Makefile.
-Description: 
+Description:
 --------------------------------------------------------------------------
 CHROOT_wrt_LogNewFiles():
 From common/libs/func_wrt_Makefile.
-Description: 
+Description:
 --------------------------------------------------------------------------
 LUSER_RemoveBuildDirs():
 From common/libs/func_wrt_Makefile.
-Description: 
+Description:
 --------------------------------------------------------------------------
 CHROOT_wrt_RemoveBuildDirs():
 From common/libs/func_wrt_Makefile.
-Description: 
+Description:
 --------------------------------------------------------------------------
 wrt_touch():
 From common/libs/func_wrt_Makefile.
-Description: 
+Description:
 --------------------------------------------------------------------------
 wrt_compare_targets():
 From common/libs/func_compare.sh.
-Description: 
+Description:
 --------------------------------------------------------------------------
 wrt_system_build():
 From common/libs/func_compare.sh.
-Description: 
+Description:
 --------------------------------------------------------------------------
 wrt_compare_work():
 From common/libs/func_compare.sh.
-Description: 
+Description:
 --------------------------------------------------------------------------
 wrt_do_ica_work():
 From common/libs/func_compare.sh.
-Description: 
+Description:
 --------------------------------------------------------------------------
 wrt_do_farce_work():
 From common/libs/func_compare.sh.
-Description: 
+Description:
 --------------------------------------------------------------------------
 wrt_logs():
 From common/libs/func_compare.sh.
-Description: 
+Description:
 --------------------------------------------------------------------------
 validate_config():
@@ -197,109 +197,109 @@
   write_error_and_die():
 From common/libs/func_validate_configs.sh.
-Description: 
+Description:
 --------------------------------------------------------------------------
   validate_file():
 From common/libs/func_validate_configs.sh.
-Description: 
+Description:
 --------------------------------------------------------------------------
   validate_dir():
 From common/libs/func_validate_configs.sh.
-Description: 
+Description:
 --------------------------------------------------------------------------
 get_book():
 From common/libs/func_book_parser.
-Description: 
+Description:
 --------------------------------------------------------------------------
 extract_commands():
 From common/libs/func_book_parser.
-Description: 
+Description:
 --------------------------------------------------------------------------
 create_package_list():
 From common/libs/func_book_parser.
-Description: 
+Description:
 --------------------------------------------------------------------------
 check_version():
 From common/libs/func_check_version.sh.
-Description: 
+Description:
 --------------------------------------------------------------------------
   write_error_and_die():
 From common/libs/func_check_version.sh.
-Description: 
+Description:
 --------------------------------------------------------------------------
 check_prerequisites():
 From common/libs/func_check_version.sh.
-Description: 
+Description:
 --------------------------------------------------------------------------
 write_or_exit():
 From common/progress_bar.sh.
-Description: 
+Description:
 --------------------------------------------------------------------------
 no_empty_builddir():
 From common/common-functions.
-Description: 
+Description:
 --------------------------------------------------------------------------
 run_make():
 From common/common-functions.
-Description: 
+Description:
 --------------------------------------------------------------------------
 clean_builddir():
 From common/common-functions.
-Description: 
+Description:
 --------------------------------------------------------------------------
 function dohelp():
 From extras/farce.
-Description: 
+Description:
 --------------------------------------------------------------------------
 function emessage():
 From extras/farce.
-Description: 
+Description:
 --------------------------------------------------------------------------
 function expected():
 From extras/farce.
-Description: 
+Description:
 --------------------------------------------------------------------------
 function failure():
 From extras/farce.
-Description: 
+Description:
 --------------------------------------------------------------------------
 function fatal():
 From extras/farce.
-Description: 
+Description:
 --------------------------------------------------------------------------
 function filetype():
 From extras/farce.
-Description: 
+Description:
 --------------------------------------------------------------------------
 function message():
 From extras/farce.
-Description: 
+Description:
 --------------------------------------------------------------------------
 function onlyone():
 From extras/farce.
-Description: 
+Description:
 --------------------------------------------------------------------------
 function testar():
 From extras/farce.
-Description: 
+Description:
 --------------------------------------------------------------------------
 function testgzip():
 From extras/farce.
-Description: 
+Description:
 --------------------------------------------------------------------------
 function testso():
 From extras/farce.
-Description: 
+Description:
 --------------------------------------------------------------------------
 function tokenize():
 From extras/farce.
-Description: 
+Description:
 --------------------------------------------------------------------------
 function tokenizeanddiff():
 From extras/farce.
-Description: 
+Description:
 --------------------------------------------------------------------------
 function validateargs():
 From extras/farce.
-Description: 
+Description:
 --------------------------------------------------------------------------
 process_toolchain():
@@ -333,25 +333,25 @@
 see_ya():
 From jhalfs.
-Description: 
+Description:
 --------------------------------------------------------------------------
 chapter4_Makefiles():
 From LFS/master.sh.
-Description: 
+Description:
 --------------------------------------------------------------------------
 chapter5_Makefiles():
 From LFS/master.sh.
-Description: 
+Description:
 --------------------------------------------------------------------------
 chapter6_Makefiles():
 From LFS/master.sh.
-Description: 
+Description:
 --------------------------------------------------------------------------
 chapter78_Makefiles():
 From LFS/master.sh.
-Description: 
+Description:
 --------------------------------------------------------------------------
 build_Makefile():
 From LFS/master.sh.
-Description: 
+Description:
 --------------------------------------------------------------------------
 validate_opt_settings():
Index: LFS/lfs.xsl
===================================================================
--- LFS/lfs.xsl	(revision dc7fd7b7bafa287dad8dd54df9b4814ef6a9f16c)
+++ LFS/lfs.xsl	(revision 2e1c1c3c167303f88f79567d4588098a71af797f)
@@ -27,5 +27,5 @@
   -->
   <xsl:param name="wrap-install" select='"n"'/>
- 
+
   <!-- Run test suites?
        0 = none
@@ -44,5 +44,5 @@
   <!-- Install vim-lang package? OBSOLETE should always be 'n'-->
   <xsl:param name="vim-lang" select="'n'"/>
-  
+
   <!-- Should we strip excutables and libraries? -->
   <xsl:param name='strip' select="'n'"/>
@@ -53,8 +53,8 @@
   <!-- Time zone -->
   <xsl:param name="timezone" select="'GMT'"/>
-  
+
   <!-- Page size -->
   <xsl:param name="page" select="'letter'"/>
-  
+
   <!-- Locale settings -->
   <xsl:param name="lang" select="'C'"/>
@@ -62,5 +62,5 @@
   <!-- Install the whole set of locales -->
   <xsl:param name='full-locale' select='"n"'/>
-  
+
   <!-- Hostname -->
   <xsl:param name='hostname' select='"HOSTNAME"'/>
@@ -83,5 +83,5 @@
                                          @revision=$revision]"/>
   </xsl:template>
-  
+
   <xsl:template match="sect1">
 <!-- Since this xsl:if tag encloses the whole template, it would
@@ -148,5 +148,5 @@
       <xsl:choose>
         <xsl:when test="@id='ch-system-creatingdirs' or
-                        @id='ch-system-createfiles' or 
+                        @id='ch-system-createfiles' or
                         @id='ch-system-strippingagain'">
           <xsl:text>#!/tools/bin/bash&#xA;set +h&#xA;</xsl:text>
@@ -407,5 +407,5 @@
     <xsl:text>&#xA;</xsl:text>
   </xsl:template>
-  
+
   <xsl:template match="userinput">
     <xsl:choose>
@@ -546,5 +546,5 @@
     </xsl:choose>
   </xsl:template>
-  
+
   <xsl:template match="replaceable">
     <xsl:choose>
@@ -593,5 +593,5 @@
     </xsl:choose>
   </xsl:template>
-  
+
   <xsl:template match="literal">
     <xsl:choose>
Index: LFS/master.sh
===================================================================
--- LFS/master.sh	(revision dc7fd7b7bafa287dad8dd54df9b4814ef6a9f16c)
+++ LFS/master.sh	(revision 2e1c1c3c167303f88f79567d4588098a71af797f)
@@ -539,5 +539,5 @@
 	fi
 
-teardown: 
+teardown:
 	sudo umount -v \$(MOUNT_PT)/sys
 	sudo umount -v \$(MOUNT_PT)/proc
Index: README
===================================================================
--- README	(revision dc7fd7b7bafa287dad8dd54df9b4814ef6a9f16c)
+++ README	(revision 2e1c1c3c167303f88f79567d4588098a71af797f)
@@ -82,5 +82,5 @@
     the packages by yourself, you should download (or copy) them to
     /mnt/build_dir/sources directly.
-    
+
        If you want to build the kernel as part of the automated build, select
     "Build the kernel" in the menu. Then, a configuration file must be
Index: README.BLFS
===================================================================
--- README.BLFS	(revision dc7fd7b7bafa287dad8dd54df9b4814ef6a9f16c)
+++ README.BLFS	(revision 2e1c1c3c167303f88f79567d4588098a71af797f)
@@ -124,5 +124,5 @@
     blfs-xml/*              SVN tree of the selected BLFS book version
     lfs-xml/*               SVN tree of the selected LFS book version
-    lib/constants.inc       functions libraries 
+    lib/constants.inc       functions libraries
        /func_dependencies     for building the dependency tree
     menu/*                  lxdialog and menuconfig source code
Index: README.PACKAGE_MANAGEMENT
===================================================================
--- README.PACKAGE_MANAGEMENT	(revision dc7fd7b7bafa287dad8dd54df9b4814ef6a9f16c)
+++ README.PACKAGE_MANAGEMENT	(revision 2e1c1c3c167303f88f79567d4588098a71af797f)
@@ -78,5 +78,5 @@
       The last thing to do is to tell how to use the package manager. The user
   has to provide two functions, "wrapInstall" and "packInstall", as described
-  above. Please note that nothing has been done to manage configuration files, 
+  above. Please note that nothing has been done to manage configuration files,
   which are ususally treated specially by package managers: depending on
   the book layout, it is sometimes possible to create those files afterwards,
Index: common/common-functions
===================================================================
--- common/common-functions	(revision dc7fd7b7bafa287dad8dd54df9b4814ef6a9f16c)
+++ common/common-functions	(revision 2e1c1c3c167303f88f79567d4588098a71af797f)
@@ -83,5 +83,5 @@
       sudo rm -rf $BUILDDIR/{opt,root,sbin,srv,tmp,tools,cross-tools,usr,var}
       echo "done"
-      if [[ "${BLFS_TOOL}" = "y" ]] ; then 
+      if [[ "${BLFS_TOOL}" = "y" ]] ; then
         echo -n "Cleaning $BUILDDIR/$BLFS_ROOT ..."
         sudo rm -rf $BUILDDIR/$BLFS_ROOT
Index: common/hostreqs.xsl
===================================================================
--- common/hostreqs.xsl	(revision dc7fd7b7bafa287dad8dd54df9b4814ef6a9f16c)
+++ common/hostreqs.xsl	(revision 2e1c1c3c167303f88f79567d4588098a71af797f)
@@ -20,5 +20,5 @@
 <!-- We assume that what is emphasized is in the form:
 aa...aa-dccsaaa (a anything except @, - "dash", d digit,
-                 c anything except space, s space) 
+                 c anything except space, s space)
 or
 aa...aasdccsaaa
Index: common/libs/func_check_version.sh
===================================================================
--- common/libs/func_check_version.sh	(revision dc7fd7b7bafa287dad8dd54df9b4814ef6a9f16c)
+++ common/libs/func_check_version.sh	(revision 2e1c1c3c167303f88f79567d4588098a71af797f)
@@ -207,5 +207,5 @@
   XMLLINT_LOC="$(whereis -b xmllint | cut -d" " -f2)"
   XSLTPROC_LOC="$(whereis -b xsltproc | cut -d" " -f2)"
-  
+
   if [ ! -x $XMLLINT_LOC ]; then
     echo "${nl_}\"${RED}xmllint${OFF}\" ${BOLD}must be installed on your system for jhalfs to run"
@@ -223,5 +223,5 @@
     check_version "2.06.20"  "${libxmlVer:0:1}.${libxmlVer:1:2}.${libxmlVer:3:2}"     "LIBXML2"
     check_version "1.01.14"  "${libxsltVer:0:1}.${libxsltVer:1:2}.${libxsltVer:3:2}"  "LIBXSLT"
-  
+
   else
     echo "${nl_}\"${RED}xsltproc${OFF}\" ${BOLD}must be installed on your system for jhalfs to run"
Index: custom/examples/960-pppd
===================================================================
--- custom/examples/960-pppd	(revision dc7fd7b7bafa287dad8dd54df9b4814ef6a9f16c)
+++ custom/examples/960-pppd	(revision 2e1c1c3c167303f88f79567d4588098a71af797f)
@@ -3,6 +3,6 @@
 #
 # The PPP package contains the pppd daemon and the chat program.
-# This is used for connecting to other machines; often for connecting 
-# to the Internet via a dial-up or PPPoE connection to an ISP. 
+# This is used for connecting to other machines; often for connecting
+# to the Internet via a dial-up or PPPoE connection to an ISP.
 #
 
Index: custom/examples/964-dhcpcd
===================================================================
--- custom/examples/964-dhcpcd	(revision dc7fd7b7bafa287dad8dd54df9b4814ef6a9f16c)
+++ custom/examples/964-dhcpcd	(revision 2e1c1c3c167303f88f79567d4588098a71af797f)
@@ -27,5 +27,5 @@
 #make install-service-dhcpcd
 
-# more configuration? 
+# more configuration?
 xEOFx
 ) > tmp
Index: custom/examples/998-syslinux
===================================================================
--- custom/examples/998-syslinux	(revision dc7fd7b7bafa287dad8dd54df9b4814ef6a9f16c)
+++ custom/examples/998-syslinux	(revision 2e1c1c3c167303f88f79567d4588098a71af797f)
@@ -8,9 +8,9 @@
 # filesystem version can be installed from DOS, NT, or
 # Linux.
-# 
+#
 # It includes a sophisticated API for add-on "COM32"
 # modules, including a significant subset of the
 # standard C library.
-# 
+#
 # It also includes MEMDISK, a tool to boot legacy
 # operating systems from nontraditional media like PXE
Index: custom/examples_CLFS-E/960-iptables
===================================================================
--- custom/examples_CLFS-E/960-iptables	(revision dc7fd7b7bafa287dad8dd54df9b4814ef6a9f16c)
+++ custom/examples_CLFS-E/960-iptables	(revision 2e1c1c3c167303f88f79567d4588098a71af797f)
@@ -5,5 +5,5 @@
 # Chapter 12 Beyond CLFS Embedded
 #
-# iptables is the userspace command line program 
+# iptables is the userspace command line program
 # used to configure the Linux firewall.
 #
Index: menu/lxdialog/BIG.FAT.WARNING
===================================================================
--- menu/lxdialog/BIG.FAT.WARNING	(revision dc7fd7b7bafa287dad8dd54df9b4814ef6a9f16c)
+++ menu/lxdialog/BIG.FAT.WARNING	(revision 2e1c1c3c167303f88f79567d4588098a71af797f)
@@ -1,4 +1,4 @@
 This is NOT the official version of dialog.  This version has been
 significantly modified from the original.  It is for use by the Linux
-kernel configuration script.  Please do not bother Savio Lam with 
+kernel configuration script.  Please do not bother Savio Lam with
 questions about this program.
Index: pkgmngt/packInstall.sh.template
===================================================================
--- pkgmngt/packInstall.sh.template	(revision dc7fd7b7bafa287dad8dd54df9b4814ef6a9f16c)
+++ pkgmngt/packInstall.sh.template	(revision 2e1c1c3c167303f88f79567d4588098a71af797f)
@@ -33,5 +33,5 @@
                              # on the system
 # The next lines are specific to dpkg, but usually all package managers
-# need some information on the version and the package. 
+# need some information on the version and the package.
 mkdir DEBIAN
 cat > DEBIAN/control <<EOF